/*
 * Dies ist UNVERÖFFENTLICHTER URHEBERRECHTLICH GESCHÜTZTER QUELLCODE der eWerk
 * IT GmbH, der Inhalt dieser Datei darf ohne die ausdrückliche Erlaubnis der
 * eWerk IT GmbH nicht an Dritte weitergegeben, kopiert oder in sonstiger Form,
 * im Ganzen oder in Teilen weitergegeben werden. Eine Weitergabe an Dritte,
 * oder Veränderungen am Programm dürfen nur mit ausdrücklicher Genehmigung der
 * eWerk IT GmbH erfolgen. Copyright 2002-2011, eWerk IT GmbH, Alle Rechte
 * vorbehalten.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of eWerk IT GmbH, the contents of
 * this file may not be disclosed to third parties, copied or duplicated in any
 * form, in whole or in part, without the prior written permission of eWerk IT
 * GmbH. Distribution to a third party or changes at the data file are only
 * allowed with the explicit permission of eWerk IT GmbH. Copyright 2002-2011,
 * eWerk IT GmbH, All rights reserved
 */
/**
 * 
 */
package com.mysql.bug;

import java.sql.DriverManager;
import java.sql.ResultSet;

import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.Statement;

/**
 * TODO h.stolzenberg: doc<br/>
 * <br/>
 * 
 * $Id$<br/>
 * <br/>
 * 
 * @author h.stolzenberg
 */
public class TimeZoneBugReproducerTest
{
	private static Logger log;

	/** Test group for manual run of developer. */
	public final static String DEVELOPER_TEST_GROUP = "DeveloperTestGroup";

	/**
	 * Sets up the test, initializes Log4J and loads test env properties.
	 * 
	 * @throws Exception
	 */
	@BeforeTest( groups = { "MysqlTestGroup" } )
	public void setup() throws Exception
	{
		DOMConfigurator.configure( TimeZoneBugReproducerTest.class.getResource( "/config/log4j.test.cfg.xml" ) );
		log = Logger.getLogger( TimeZoneBugReproducerTest.class );
	}

	/**
	 * TODO h.stolzenberg: dokumentation
	 */
	@Test( groups = { "MysqlTestGroup" } )
	public void testReproduceBug()
	{
		log.debug( "Starting Bug reproduction ..." );

		Connection con = null;
		Statement st = null;
		ResultSet rs = null;

		try
		{
			con = (Connection) DriverManager.getConnection( "jdbc:mysql://localhost:3306/tz_bug?autoReconnect=true&useUnicode=true&characterEncoding=UTF-8&zeroDateTimeBehavior=convertToNull&useTimezone=true&serverTimezone=UTC&noTimezoneConversionForTimeType=false&jdbcCompliantTruncation=false",
															"developer",
															"test" );
			st = (Statement) con.createStatement();
			st.execute( "SET TIME_ZONE='UTC'" );
			st.close();

			st = (Statement) con.createStatement();
			rs = st.executeQuery( "SELECT CASE WHEN HOUR(timepoint)=2 THEN 'ERR' ELSE 'OK' END, t1.timepoint FROM test_data AS t1" );

			while ( rs.next() )
			{
				log.debug( "=> [" + rs.getString( 1 ) + "] [" + rs.getDate( 2 ) + " " + rs.getTime( 2 ) + "] <> [" + rs.getTimestamp( 2 ) + "]" );
			}
		}
		catch ( final Exception e )
		{
			log.error( e.getMessage(), e );
		}
		finally
		{
			cleanup( rs, st, con );
		}
	}

	private void cleanup(	final ResultSet rs,
							final Statement st,
							final Connection con )
	{
		try
		{
			if ( rs != null )
			{
				rs.close();
			}
			if ( st != null )
			{
				st.close();
			}
			if ( con != null )
			{
				con.close();
			}
		}
		catch ( final Exception e )
		{
			log.error( e );
		}
	}
}